// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.


using System;
using System.Runtime.InteropServices;
using System.Runtime.CompilerServices;
using System.Text;
using Silk.NET.Core;
using Silk.NET.Core.Native;
using Silk.NET.Core.Attributes;
using Silk.NET.Core.Contexts;
using Silk.NET.Core.Loader;

#pragma warning disable 1591

namespace Silk.NET.Assimp
{
    [NativeName("Name", "aiPropertyStore")]
    public unsafe partial struct PropertyStore
    {
        public PropertyStore
        (
            byte? sentinel = null
        ) : this()
        {
            if (sentinel is not null)
            {
                Sentinel = sentinel.Value;
            }
        }


        [NativeName("Type", "char")]
        [NativeName("Type.Name", "char")]
        [NativeName("Name", "sentinel")]
        public byte Sentinel;
    }
}
