// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.


using System;
using System.Runtime.InteropServices;
using System.Runtime.CompilerServices;
using System.Text;
using Silk.NET.Core;
using Silk.NET.Core.Native;
using Silk.NET.Core.Attributes;
using Silk.NET.Core.Contexts;
using Silk.NET.Core.Loader;

#pragma warning disable 1591

namespace Silk.NET.Core.Win32Extras
{
    [NativeName("Name", "_RIP_INFO")]
    public unsafe partial struct RipInfo
    {
        public RipInfo
        (
            uint? dwError = null,
            uint? dwType = null
        ) : this()
        {
            if (dwError is not null)
            {
                DwError = dwError.Value;
            }

            if (dwType is not null)
            {
                DwType = dwType.Value;
            }
        }


        [NativeName("Type", "DWORD")]
        [NativeName("Type.Name", "DWORD")]
        [NativeName("Name", "dwError")]
        public uint DwError;

        [NativeName("Type", "DWORD")]
        [NativeName("Type.Name", "DWORD")]
        [NativeName("Name", "dwType")]
        public uint DwType;
    }
}
