// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.


using System;
using System.Runtime.InteropServices;
using System.Runtime.CompilerServices;
using System.Text;
using Silk.NET.Core;
using Silk.NET.Core.Native;
using Silk.NET.Core.Attributes;
using Silk.NET.Core.Contexts;
using Silk.NET.Core.Loader;

#pragma warning disable 1591

namespace Silk.NET.DXGI
{
    [NativeName("Name", "DXGI_GAMMA_CONTROL")]
    public unsafe partial struct GammaControl
    {
        public GammaControl
        (
            Rgb? scale = null,
            Rgb? offset = null
        ) : this()
        {
            if (scale is not null)
            {
                Scale = scale.Value;
            }

            if (offset is not null)
            {
                Offset = offset.Value;
            }
        }


        [NativeName("Type", "DXGI_RGB")]
        [NativeName("Type.Name", "DXGI_RGB")]
        [NativeName("Name", "Scale")]
        public Rgb Scale;

        [NativeName("Type", "DXGI_RGB")]
        [NativeName("Type.Name", "DXGI_RGB")]
        [NativeName("Name", "Offset")]
        public Rgb Offset;
        
        [NativeName("Type", "DXGI_RGB [1025]")]
        [NativeName("Type.Name", "DXGI_RGB [1025]")]
        [NativeName("Name", "GammaCurve")]
        public GammaCurveBuffer GammaCurve;

        public struct GammaCurveBuffer
        {
            public Rgb Element0;
            public Rgb Element1;
            public Rgb Element2;
            public Rgb Element3;
            public Rgb Element4;
            public Rgb Element5;
            public Rgb Element6;
            public Rgb Element7;
            public Rgb Element8;
            public Rgb Element9;
            public Rgb Element10;
            public Rgb Element11;
            public Rgb Element12;
            public Rgb Element13;
            public Rgb Element14;
            public Rgb Element15;
            public Rgb Element16;
            public Rgb Element17;
            public Rgb Element18;
            public Rgb Element19;
            public Rgb Element20;
            public Rgb Element21;
            public Rgb Element22;
            public Rgb Element23;
            public Rgb Element24;
            public Rgb Element25;
            public Rgb Element26;
            public Rgb Element27;
            public Rgb Element28;
            public Rgb Element29;
            public Rgb Element30;
            public Rgb Element31;
            public Rgb Element32;
            public Rgb Element33;
            public Rgb Element34;
            public Rgb Element35;
            public Rgb Element36;
            public Rgb Element37;
            public Rgb Element38;
            public Rgb Element39;
            public Rgb Element40;
            public Rgb Element41;
            public Rgb Element42;
            public Rgb Element43;
            public Rgb Element44;
            public Rgb Element45;
            public Rgb Element46;
            public Rgb Element47;
            public Rgb Element48;
            public Rgb Element49;
            public Rgb Element50;
            public Rgb Element51;
            public Rgb Element52;
            public Rgb Element53;
            public Rgb Element54;
            public Rgb Element55;
            public Rgb Element56;
            public Rgb Element57;
            public Rgb Element58;
            public Rgb Element59;
            public Rgb Element60;
            public Rgb Element61;
            public Rgb Element62;
            public Rgb Element63;
            public Rgb Element64;
            public Rgb Element65;
            public Rgb Element66;
            public Rgb Element67;
            public Rgb Element68;
            public Rgb Element69;
            public Rgb Element70;
            public Rgb Element71;
            public Rgb Element72;
            public Rgb Element73;
            public Rgb Element74;
            public Rgb Element75;
            public Rgb Element76;
            public Rgb Element77;
            public Rgb Element78;
            public Rgb Element79;
            public Rgb Element80;
            public Rgb Element81;
            public Rgb Element82;
            public Rgb Element83;
            public Rgb Element84;
            public Rgb Element85;
            public Rgb Element86;
            public Rgb Element87;
            public Rgb Element88;
            public Rgb Element89;
            public Rgb Element90;
            public Rgb Element91;
            public Rgb Element92;
            public Rgb Element93;
            public Rgb Element94;
            public Rgb Element95;
            public Rgb Element96;
            public Rgb Element97;
            public Rgb Element98;
            public Rgb Element99;
            public Rgb Element100;
            public Rgb Element101;
            public Rgb Element102;
            public Rgb Element103;
            public Rgb Element104;
            public Rgb Element105;
            public Rgb Element106;
            public Rgb Element107;
            public Rgb Element108;
            public Rgb Element109;
            public Rgb Element110;
            public Rgb Element111;
            public Rgb Element112;
            public Rgb Element113;
            public Rgb Element114;
            public Rgb Element115;
            public Rgb Element116;
            public Rgb Element117;
            public Rgb Element118;
            public Rgb Element119;
            public Rgb Element120;
            public Rgb Element121;
            public Rgb Element122;
            public Rgb Element123;
            public Rgb Element124;
            public Rgb Element125;
            public Rgb Element126;
            public Rgb Element127;
            public Rgb Element128;
            public Rgb Element129;
            public Rgb Element130;
            public Rgb Element131;
            public Rgb Element132;
            public Rgb Element133;
            public Rgb Element134;
            public Rgb Element135;
            public Rgb Element136;
            public Rgb Element137;
            public Rgb Element138;
            public Rgb Element139;
            public Rgb Element140;
            public Rgb Element141;
            public Rgb Element142;
            public Rgb Element143;
            public Rgb Element144;
            public Rgb Element145;
            public Rgb Element146;
            public Rgb Element147;
            public Rgb Element148;
            public Rgb Element149;
            public Rgb Element150;
            public Rgb Element151;
            public Rgb Element152;
            public Rgb Element153;
            public Rgb Element154;
            public Rgb Element155;
            public Rgb Element156;
            public Rgb Element157;
            public Rgb Element158;
            public Rgb Element159;
            public Rgb Element160;
            public Rgb Element161;
            public Rgb Element162;
            public Rgb Element163;
            public Rgb Element164;
            public Rgb Element165;
            public Rgb Element166;
            public Rgb Element167;
            public Rgb Element168;
            public Rgb Element169;
            public Rgb Element170;
            public Rgb Element171;
            public Rgb Element172;
            public Rgb Element173;
            public Rgb Element174;
            public Rgb Element175;
            public Rgb Element176;
            public Rgb Element177;
            public Rgb Element178;
            public Rgb Element179;
            public Rgb Element180;
            public Rgb Element181;
            public Rgb Element182;
            public Rgb Element183;
            public Rgb Element184;
            public Rgb Element185;
            public Rgb Element186;
            public Rgb Element187;
            public Rgb Element188;
            public Rgb Element189;
            public Rgb Element190;
            public Rgb Element191;
            public Rgb Element192;
            public Rgb Element193;
            public Rgb Element194;
            public Rgb Element195;
            public Rgb Element196;
            public Rgb Element197;
            public Rgb Element198;
            public Rgb Element199;
            public Rgb Element200;
            public Rgb Element201;
            public Rgb Element202;
            public Rgb Element203;
            public Rgb Element204;
            public Rgb Element205;
            public Rgb Element206;
            public Rgb Element207;
            public Rgb Element208;
            public Rgb Element209;
            public Rgb Element210;
            public Rgb Element211;
            public Rgb Element212;
            public Rgb Element213;
            public Rgb Element214;
            public Rgb Element215;
            public Rgb Element216;
            public Rgb Element217;
            public Rgb Element218;
            public Rgb Element219;
            public Rgb Element220;
            public Rgb Element221;
            public Rgb Element222;
            public Rgb Element223;
            public Rgb Element224;
            public Rgb Element225;
            public Rgb Element226;
            public Rgb Element227;
            public Rgb Element228;
            public Rgb Element229;
            public Rgb Element230;
            public Rgb Element231;
            public Rgb Element232;
            public Rgb Element233;
            public Rgb Element234;
            public Rgb Element235;
            public Rgb Element236;
            public Rgb Element237;
            public Rgb Element238;
            public Rgb Element239;
            public Rgb Element240;
            public Rgb Element241;
            public Rgb Element242;
            public Rgb Element243;
            public Rgb Element244;
            public Rgb Element245;
            public Rgb Element246;
            public Rgb Element247;
            public Rgb Element248;
            public Rgb Element249;
            public Rgb Element250;
            public Rgb Element251;
            public Rgb Element252;
            public Rgb Element253;
            public Rgb Element254;
            public Rgb Element255;
            public Rgb Element256;
            public Rgb Element257;
            public Rgb Element258;
            public Rgb Element259;
            public Rgb Element260;
            public Rgb Element261;
            public Rgb Element262;
            public Rgb Element263;
            public Rgb Element264;
            public Rgb Element265;
            public Rgb Element266;
            public Rgb Element267;
            public Rgb Element268;
            public Rgb Element269;
            public Rgb Element270;
            public Rgb Element271;
            public Rgb Element272;
            public Rgb Element273;
            public Rgb Element274;
            public Rgb Element275;
            public Rgb Element276;
            public Rgb Element277;
            public Rgb Element278;
            public Rgb Element279;
            public Rgb Element280;
            public Rgb Element281;
            public Rgb Element282;
            public Rgb Element283;
            public Rgb Element284;
            public Rgb Element285;
            public Rgb Element286;
            public Rgb Element287;
            public Rgb Element288;
            public Rgb Element289;
            public Rgb Element290;
            public Rgb Element291;
            public Rgb Element292;
            public Rgb Element293;
            public Rgb Element294;
            public Rgb Element295;
            public Rgb Element296;
            public Rgb Element297;
            public Rgb Element298;
            public Rgb Element299;
            public Rgb Element300;
            public Rgb Element301;
            public Rgb Element302;
            public Rgb Element303;
            public Rgb Element304;
            public Rgb Element305;
            public Rgb Element306;
            public Rgb Element307;
            public Rgb Element308;
            public Rgb Element309;
            public Rgb Element310;
            public Rgb Element311;
            public Rgb Element312;
            public Rgb Element313;
            public Rgb Element314;
            public Rgb Element315;
            public Rgb Element316;
            public Rgb Element317;
            public Rgb Element318;
            public Rgb Element319;
            public Rgb Element320;
            public Rgb Element321;
            public Rgb Element322;
            public Rgb Element323;
            public Rgb Element324;
            public Rgb Element325;
            public Rgb Element326;
            public Rgb Element327;
            public Rgb Element328;
            public Rgb Element329;
            public Rgb Element330;
            public Rgb Element331;
            public Rgb Element332;
            public Rgb Element333;
            public Rgb Element334;
            public Rgb Element335;
            public Rgb Element336;
            public Rgb Element337;
            public Rgb Element338;
            public Rgb Element339;
            public Rgb Element340;
            public Rgb Element341;
            public Rgb Element342;
            public Rgb Element343;
            public Rgb Element344;
            public Rgb Element345;
            public Rgb Element346;
            public Rgb Element347;
            public Rgb Element348;
            public Rgb Element349;
            public Rgb Element350;
            public Rgb Element351;
            public Rgb Element352;
            public Rgb Element353;
            public Rgb Element354;
            public Rgb Element355;
            public Rgb Element356;
            public Rgb Element357;
            public Rgb Element358;
            public Rgb Element359;
            public Rgb Element360;
            public Rgb Element361;
            public Rgb Element362;
            public Rgb Element363;
            public Rgb Element364;
            public Rgb Element365;
            public Rgb Element366;
            public Rgb Element367;
            public Rgb Element368;
            public Rgb Element369;
            public Rgb Element370;
            public Rgb Element371;
            public Rgb Element372;
            public Rgb Element373;
            public Rgb Element374;
            public Rgb Element375;
            public Rgb Element376;
            public Rgb Element377;
            public Rgb Element378;
            public Rgb Element379;
            public Rgb Element380;
            public Rgb Element381;
            public Rgb Element382;
            public Rgb Element383;
            public Rgb Element384;
            public Rgb Element385;
            public Rgb Element386;
            public Rgb Element387;
            public Rgb Element388;
            public Rgb Element389;
            public Rgb Element390;
            public Rgb Element391;
            public Rgb Element392;
            public Rgb Element393;
            public Rgb Element394;
            public Rgb Element395;
            public Rgb Element396;
            public Rgb Element397;
            public Rgb Element398;
            public Rgb Element399;
            public Rgb Element400;
            public Rgb Element401;
            public Rgb Element402;
            public Rgb Element403;
            public Rgb Element404;
            public Rgb Element405;
            public Rgb Element406;
            public Rgb Element407;
            public Rgb Element408;
            public Rgb Element409;
            public Rgb Element410;
            public Rgb Element411;
            public Rgb Element412;
            public Rgb Element413;
            public Rgb Element414;
            public Rgb Element415;
            public Rgb Element416;
            public Rgb Element417;
            public Rgb Element418;
            public Rgb Element419;
            public Rgb Element420;
            public Rgb Element421;
            public Rgb Element422;
            public Rgb Element423;
            public Rgb Element424;
            public Rgb Element425;
            public Rgb Element426;
            public Rgb Element427;
            public Rgb Element428;
            public Rgb Element429;
            public Rgb Element430;
            public Rgb Element431;
            public Rgb Element432;
            public Rgb Element433;
            public Rgb Element434;
            public Rgb Element435;
            public Rgb Element436;
            public Rgb Element437;
            public Rgb Element438;
            public Rgb Element439;
            public Rgb Element440;
            public Rgb Element441;
            public Rgb Element442;
            public Rgb Element443;
            public Rgb Element444;
            public Rgb Element445;
            public Rgb Element446;
            public Rgb Element447;
            public Rgb Element448;
            public Rgb Element449;
            public Rgb Element450;
            public Rgb Element451;
            public Rgb Element452;
            public Rgb Element453;
            public Rgb Element454;
            public Rgb Element455;
            public Rgb Element456;
            public Rgb Element457;
            public Rgb Element458;
            public Rgb Element459;
            public Rgb Element460;
            public Rgb Element461;
            public Rgb Element462;
            public Rgb Element463;
            public Rgb Element464;
            public Rgb Element465;
            public Rgb Element466;
            public Rgb Element467;
            public Rgb Element468;
            public Rgb Element469;
            public Rgb Element470;
            public Rgb Element471;
            public Rgb Element472;
            public Rgb Element473;
            public Rgb Element474;
            public Rgb Element475;
            public Rgb Element476;
            public Rgb Element477;
            public Rgb Element478;
            public Rgb Element479;
            public Rgb Element480;
            public Rgb Element481;
            public Rgb Element482;
            public Rgb Element483;
            public Rgb Element484;
            public Rgb Element485;
            public Rgb Element486;
            public Rgb Element487;
            public Rgb Element488;
            public Rgb Element489;
            public Rgb Element490;
            public Rgb Element491;
            public Rgb Element492;
            public Rgb Element493;
            public Rgb Element494;
            public Rgb Element495;
            public Rgb Element496;
            public Rgb Element497;
            public Rgb Element498;
            public Rgb Element499;
            public Rgb Element500;
            public Rgb Element501;
            public Rgb Element502;
            public Rgb Element503;
            public Rgb Element504;
            public Rgb Element505;
            public Rgb Element506;
            public Rgb Element507;
            public Rgb Element508;
            public Rgb Element509;
            public Rgb Element510;
            public Rgb Element511;
            public Rgb Element512;
            public Rgb Element513;
            public Rgb Element514;
            public Rgb Element515;
            public Rgb Element516;
            public Rgb Element517;
            public Rgb Element518;
            public Rgb Element519;
            public Rgb Element520;
            public Rgb Element521;
            public Rgb Element522;
            public Rgb Element523;
            public Rgb Element524;
            public Rgb Element525;
            public Rgb Element526;
            public Rgb Element527;
            public Rgb Element528;
            public Rgb Element529;
            public Rgb Element530;
            public Rgb Element531;
            public Rgb Element532;
            public Rgb Element533;
            public Rgb Element534;
            public Rgb Element535;
            public Rgb Element536;
            public Rgb Element537;
            public Rgb Element538;
            public Rgb Element539;
            public Rgb Element540;
            public Rgb Element541;
            public Rgb Element542;
            public Rgb Element543;
            public Rgb Element544;
            public Rgb Element545;
            public Rgb Element546;
            public Rgb Element547;
            public Rgb Element548;
            public Rgb Element549;
            public Rgb Element550;
            public Rgb Element551;
            public Rgb Element552;
            public Rgb Element553;
            public Rgb Element554;
            public Rgb Element555;
            public Rgb Element556;
            public Rgb Element557;
            public Rgb Element558;
            public Rgb Element559;
            public Rgb Element560;
            public Rgb Element561;
            public Rgb Element562;
            public Rgb Element563;
            public Rgb Element564;
            public Rgb Element565;
            public Rgb Element566;
            public Rgb Element567;
            public Rgb Element568;
            public Rgb Element569;
            public Rgb Element570;
            public Rgb Element571;
            public Rgb Element572;
            public Rgb Element573;
            public Rgb Element574;
            public Rgb Element575;
            public Rgb Element576;
            public Rgb Element577;
            public Rgb Element578;
            public Rgb Element579;
            public Rgb Element580;
            public Rgb Element581;
            public Rgb Element582;
            public Rgb Element583;
            public Rgb Element584;
            public Rgb Element585;
            public Rgb Element586;
            public Rgb Element587;
            public Rgb Element588;
            public Rgb Element589;
            public Rgb Element590;
            public Rgb Element591;
            public Rgb Element592;
            public Rgb Element593;
            public Rgb Element594;
            public Rgb Element595;
            public Rgb Element596;
            public Rgb Element597;
            public Rgb Element598;
            public Rgb Element599;
            public Rgb Element600;
            public Rgb Element601;
            public Rgb Element602;
            public Rgb Element603;
            public Rgb Element604;
            public Rgb Element605;
            public Rgb Element606;
            public Rgb Element607;
            public Rgb Element608;
            public Rgb Element609;
            public Rgb Element610;
            public Rgb Element611;
            public Rgb Element612;
            public Rgb Element613;
            public Rgb Element614;
            public Rgb Element615;
            public Rgb Element616;
            public Rgb Element617;
            public Rgb Element618;
            public Rgb Element619;
            public Rgb Element620;
            public Rgb Element621;
            public Rgb Element622;
            public Rgb Element623;
            public Rgb Element624;
            public Rgb Element625;
            public Rgb Element626;
            public Rgb Element627;
            public Rgb Element628;
            public Rgb Element629;
            public Rgb Element630;
            public Rgb Element631;
            public Rgb Element632;
            public Rgb Element633;
            public Rgb Element634;
            public Rgb Element635;
            public Rgb Element636;
            public Rgb Element637;
            public Rgb Element638;
            public Rgb Element639;
            public Rgb Element640;
            public Rgb Element641;
            public Rgb Element642;
            public Rgb Element643;
            public Rgb Element644;
            public Rgb Element645;
            public Rgb Element646;
            public Rgb Element647;
            public Rgb Element648;
            public Rgb Element649;
            public Rgb Element650;
            public Rgb Element651;
            public Rgb Element652;
            public Rgb Element653;
            public Rgb Element654;
            public Rgb Element655;
            public Rgb Element656;
            public Rgb Element657;
            public Rgb Element658;
            public Rgb Element659;
            public Rgb Element660;
            public Rgb Element661;
            public Rgb Element662;
            public Rgb Element663;
            public Rgb Element664;
            public Rgb Element665;
            public Rgb Element666;
            public Rgb Element667;
            public Rgb Element668;
            public Rgb Element669;
            public Rgb Element670;
            public Rgb Element671;
            public Rgb Element672;
            public Rgb Element673;
            public Rgb Element674;
            public Rgb Element675;
            public Rgb Element676;
            public Rgb Element677;
            public Rgb Element678;
            public Rgb Element679;
            public Rgb Element680;
            public Rgb Element681;
            public Rgb Element682;
            public Rgb Element683;
            public Rgb Element684;
            public Rgb Element685;
            public Rgb Element686;
            public Rgb Element687;
            public Rgb Element688;
            public Rgb Element689;
            public Rgb Element690;
            public Rgb Element691;
            public Rgb Element692;
            public Rgb Element693;
            public Rgb Element694;
            public Rgb Element695;
            public Rgb Element696;
            public Rgb Element697;
            public Rgb Element698;
            public Rgb Element699;
            public Rgb Element700;
            public Rgb Element701;
            public Rgb Element702;
            public Rgb Element703;
            public Rgb Element704;
            public Rgb Element705;
            public Rgb Element706;
            public Rgb Element707;
            public Rgb Element708;
            public Rgb Element709;
            public Rgb Element710;
            public Rgb Element711;
            public Rgb Element712;
            public Rgb Element713;
            public Rgb Element714;
            public Rgb Element715;
            public Rgb Element716;
            public Rgb Element717;
            public Rgb Element718;
            public Rgb Element719;
            public Rgb Element720;
            public Rgb Element721;
            public Rgb Element722;
            public Rgb Element723;
            public Rgb Element724;
            public Rgb Element725;
            public Rgb Element726;
            public Rgb Element727;
            public Rgb Element728;
            public Rgb Element729;
            public Rgb Element730;
            public Rgb Element731;
            public Rgb Element732;
            public Rgb Element733;
            public Rgb Element734;
            public Rgb Element735;
            public Rgb Element736;
            public Rgb Element737;
            public Rgb Element738;
            public Rgb Element739;
            public Rgb Element740;
            public Rgb Element741;
            public Rgb Element742;
            public Rgb Element743;
            public Rgb Element744;
            public Rgb Element745;
            public Rgb Element746;
            public Rgb Element747;
            public Rgb Element748;
            public Rgb Element749;
            public Rgb Element750;
            public Rgb Element751;
            public Rgb Element752;
            public Rgb Element753;
            public Rgb Element754;
            public Rgb Element755;
            public Rgb Element756;
            public Rgb Element757;
            public Rgb Element758;
            public Rgb Element759;
            public Rgb Element760;
            public Rgb Element761;
            public Rgb Element762;
            public Rgb Element763;
            public Rgb Element764;
            public Rgb Element765;
            public Rgb Element766;
            public Rgb Element767;
            public Rgb Element768;
            public Rgb Element769;
            public Rgb Element770;
            public Rgb Element771;
            public Rgb Element772;
            public Rgb Element773;
            public Rgb Element774;
            public Rgb Element775;
            public Rgb Element776;
            public Rgb Element777;
            public Rgb Element778;
            public Rgb Element779;
            public Rgb Element780;
            public Rgb Element781;
            public Rgb Element782;
            public Rgb Element783;
            public Rgb Element784;
            public Rgb Element785;
            public Rgb Element786;
            public Rgb Element787;
            public Rgb Element788;
            public Rgb Element789;
            public Rgb Element790;
            public Rgb Element791;
            public Rgb Element792;
            public Rgb Element793;
            public Rgb Element794;
            public Rgb Element795;
            public Rgb Element796;
            public Rgb Element797;
            public Rgb Element798;
            public Rgb Element799;
            public Rgb Element800;
            public Rgb Element801;
            public Rgb Element802;
            public Rgb Element803;
            public Rgb Element804;
            public Rgb Element805;
            public Rgb Element806;
            public Rgb Element807;
            public Rgb Element808;
            public Rgb Element809;
            public Rgb Element810;
            public Rgb Element811;
            public Rgb Element812;
            public Rgb Element813;
            public Rgb Element814;
            public Rgb Element815;
            public Rgb Element816;
            public Rgb Element817;
            public Rgb Element818;
            public Rgb Element819;
            public Rgb Element820;
            public Rgb Element821;
            public Rgb Element822;
            public Rgb Element823;
            public Rgb Element824;
            public Rgb Element825;
            public Rgb Element826;
            public Rgb Element827;
            public Rgb Element828;
            public Rgb Element829;
            public Rgb Element830;
            public Rgb Element831;
            public Rgb Element832;
            public Rgb Element833;
            public Rgb Element834;
            public Rgb Element835;
            public Rgb Element836;
            public Rgb Element837;
            public Rgb Element838;
            public Rgb Element839;
            public Rgb Element840;
            public Rgb Element841;
            public Rgb Element842;
            public Rgb Element843;
            public Rgb Element844;
            public Rgb Element845;
            public Rgb Element846;
            public Rgb Element847;
            public Rgb Element848;
            public Rgb Element849;
            public Rgb Element850;
            public Rgb Element851;
            public Rgb Element852;
            public Rgb Element853;
            public Rgb Element854;
            public Rgb Element855;
            public Rgb Element856;
            public Rgb Element857;
            public Rgb Element858;
            public Rgb Element859;
            public Rgb Element860;
            public Rgb Element861;
            public Rgb Element862;
            public Rgb Element863;
            public Rgb Element864;
            public Rgb Element865;
            public Rgb Element866;
            public Rgb Element867;
            public Rgb Element868;
            public Rgb Element869;
            public Rgb Element870;
            public Rgb Element871;
            public Rgb Element872;
            public Rgb Element873;
            public Rgb Element874;
            public Rgb Element875;
            public Rgb Element876;
            public Rgb Element877;
            public Rgb Element878;
            public Rgb Element879;
            public Rgb Element880;
            public Rgb Element881;
            public Rgb Element882;
            public Rgb Element883;
            public Rgb Element884;
            public Rgb Element885;
            public Rgb Element886;
            public Rgb Element887;
            public Rgb Element888;
            public Rgb Element889;
            public Rgb Element890;
            public Rgb Element891;
            public Rgb Element892;
            public Rgb Element893;
            public Rgb Element894;
            public Rgb Element895;
            public Rgb Element896;
            public Rgb Element897;
            public Rgb Element898;
            public Rgb Element899;
            public Rgb Element900;
            public Rgb Element901;
            public Rgb Element902;
            public Rgb Element903;
            public Rgb Element904;
            public Rgb Element905;
            public Rgb Element906;
            public Rgb Element907;
            public Rgb Element908;
            public Rgb Element909;
            public Rgb Element910;
            public Rgb Element911;
            public Rgb Element912;
            public Rgb Element913;
            public Rgb Element914;
            public Rgb Element915;
            public Rgb Element916;
            public Rgb Element917;
            public Rgb Element918;
            public Rgb Element919;
            public Rgb Element920;
            public Rgb Element921;
            public Rgb Element922;
            public Rgb Element923;
            public Rgb Element924;
            public Rgb Element925;
            public Rgb Element926;
            public Rgb Element927;
            public Rgb Element928;
            public Rgb Element929;
            public Rgb Element930;
            public Rgb Element931;
            public Rgb Element932;
            public Rgb Element933;
            public Rgb Element934;
            public Rgb Element935;
            public Rgb Element936;
            public Rgb Element937;
            public Rgb Element938;
            public Rgb Element939;
            public Rgb Element940;
            public Rgb Element941;
            public Rgb Element942;
            public Rgb Element943;
            public Rgb Element944;
            public Rgb Element945;
            public Rgb Element946;
            public Rgb Element947;
            public Rgb Element948;
            public Rgb Element949;
            public Rgb Element950;
            public Rgb Element951;
            public Rgb Element952;
            public Rgb Element953;
            public Rgb Element954;
            public Rgb Element955;
            public Rgb Element956;
            public Rgb Element957;
            public Rgb Element958;
            public Rgb Element959;
            public Rgb Element960;
            public Rgb Element961;
            public Rgb Element962;
            public Rgb Element963;
            public Rgb Element964;
            public Rgb Element965;
            public Rgb Element966;
            public Rgb Element967;
            public Rgb Element968;
            public Rgb Element969;
            public Rgb Element970;
            public Rgb Element971;
            public Rgb Element972;
            public Rgb Element973;
            public Rgb Element974;
            public Rgb Element975;
            public Rgb Element976;
            public Rgb Element977;
            public Rgb Element978;
            public Rgb Element979;
            public Rgb Element980;
            public Rgb Element981;
            public Rgb Element982;
            public Rgb Element983;
            public Rgb Element984;
            public Rgb Element985;
            public Rgb Element986;
            public Rgb Element987;
            public Rgb Element988;
            public Rgb Element989;
            public Rgb Element990;
            public Rgb Element991;
            public Rgb Element992;
            public Rgb Element993;
            public Rgb Element994;
            public Rgb Element995;
            public Rgb Element996;
            public Rgb Element997;
            public Rgb Element998;
            public Rgb Element999;
            public Rgb Element1000;
            public Rgb Element1001;
            public Rgb Element1002;
            public Rgb Element1003;
            public Rgb Element1004;
            public Rgb Element1005;
            public Rgb Element1006;
            public Rgb Element1007;
            public Rgb Element1008;
            public Rgb Element1009;
            public Rgb Element1010;
            public Rgb Element1011;
            public Rgb Element1012;
            public Rgb Element1013;
            public Rgb Element1014;
            public Rgb Element1015;
            public Rgb Element1016;
            public Rgb Element1017;
            public Rgb Element1018;
            public Rgb Element1019;
            public Rgb Element1020;
            public Rgb Element1021;
            public Rgb Element1022;
            public Rgb Element1023;
            public Rgb Element1024;
            public ref Rgb this[int index]
            {
                get
                {
                    if (index > 1024 || index < 0)
                    {
                        throw new ArgumentOutOfRangeException(nameof(index));
                    }

                    fixed (Rgb* ptr = &Element0)
                    {
                        return ref ptr[index];
                    }
                }
            }

#if NETSTANDARD2_1 || NETCOREAPP3_1 || NET5_0 || NET5_0_OR_GREATER
            public Span<Rgb> AsSpan()
                => MemoryMarshal.CreateSpan(ref Element0, 1025);
#endif
        }

    }
}
