// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.


using System;
using System.Runtime.InteropServices;
using System.Runtime.CompilerServices;
using System.Text;
using Silk.NET.Core;
using Silk.NET.Core.Native;
using Silk.NET.Core.Attributes;
using Silk.NET.Core.Contexts;
using Silk.NET.Core.Loader;

#pragma warning disable 1591

namespace Silk.NET.OpenXR
{
    [NativeName("Name", "XrSceneOrientedBoxBoundMSFT")]
    public unsafe partial struct SceneOrientedBoxBoundMSFT
    {
        public SceneOrientedBoxBoundMSFT
        (
            Posef? pose = null,
            Vector3f? extents = null
        ) : this()
        {
            if (pose is not null)
            {
                Pose = pose.Value;
            }

            if (extents is not null)
            {
                Extents = extents.Value;
            }
        }

/// <summary></summary>
        [NativeName("Type", "XrPosef")]
        [NativeName("Type.Name", "XrPosef")]
        [NativeName("Name", "pose")]
        public Posef Pose;
/// <summary></summary>
        [NativeName("Type", "XrVector3f")]
        [NativeName("Type.Name", "XrVector3f")]
        [NativeName("Name", "extents")]
        public Vector3f Extents;
    }
}
